import { IGQLType } from 'prisma-datamodel';
import { Data } from './data';
/**
 * Infers structure of a datatype from a set of data samples.
 */
export declare class ModelMerger {
    private fields;
    private embeddedTypes;
    name: string;
    isEmbedded: boolean;
    static ErrorType: string;
    constructor(name: string, isEmbedded?: boolean);
    analyze(data: Data): void;
    /**
     * Gets the top level type only.
     */
    getTopLevelType(): IGQLType;
    /**
     * Gets the type with embedded types attached recursivley.
     */
    getType(): {
        type: IGQLType;
        embedded: IGQLType[];
    };
    private summarizeTypeList;
    private toIGQLField;
    private initField;
    private analyzeField;
    private mergeField;
    private merge;
    private inferArrayType;
    private inferType;
}
